ALTER TABLE SBI_ORG_UNIT ALTER COLUMN NAME type varchar(200);

ALTER TABLE SBI_OBJECT_NOTES
	ALTER COLUMN ISPUBLIC TYPE boolean
		USING CASE WHEN ISPUBLIC = 0 THEN FALSE
			WHEN ISPUBLIC = 1 THEN TRUE
			ELSE NULL
			END;
			
CREATE SEQUENCE SBI_GOAL_SEQ INCREMENT 1 START  1 ;
CREATE SEQUENCE SBI_GOAL_HIERARCHY_SEQ INCREMENT 1 START  1 ;
CREATE SEQUENCE SBI_GOAL_KPI_SEQ INCREMENT 1 START  1 ;


CREATE TABLE SBI_GOAL (
  GOAL_ID       INTEGER DEFAULT nextval('SBI_GOAL_SEQ') NOT NULL,
  GRANT_ID      INTEGER NOT NULL,
  START_DATE    DATE NOT NULL,
  END_DATE      DATE NOT NULL,
  NAME          VARCHAR(20) NOT NULL,
  LABEL          VARCHAR(20) NOT NULL,
  DESCRIPTION		VARCHAR(1000),
  CONSTRAINT XPKSBI_GOAL PRIMARY KEY (GOAL_ID)
) WITHOUT OIDS;


CREATE TABLE SBI_GOAL_HIERARCHY (
  GOAL_HIERARCHY_ID INTEGER DEFAULT nextval('SBI_GOAL_HIERARCHY_SEQ') NOT NULL,
  ORG_UNIT_ID       INTEGER NOT NULL,
  GOAL_ID           INTEGER NOT NULL,
  PARENT_ID         INTEGER,
  NAME              VARCHAR(50) NOT NULL,
  LABEL             VARCHAR(50),
  GOAL              VARCHAR(1000),
  CONSTRAINT XPKSBI_GOAL_HIERARCHY PRIMARY KEY (GOAL_HIERARCHY_ID)
) WITHOUT OIDS;


CREATE TABLE SBI_GOAL_KPI (
  GOAL_KPI_ID         INTEGER DEFAULT nextval('SBI_GOAL_KPI_SEQ') NOT NULL,
  KPI_INSTANCE_ID     INTEGER NOT NULL,
  GOAL_HIERARCHY_ID   INTEGER NOT NULL,
  WEIGHT1             FLOAT(8),
  WEIGHT2             FLOAT(8),
  THRESHOLD1          FLOAT(8),
  THRESHOLD2          FLOAT(8),
  THRESHOLD1SIGN      INTEGER,
  THRESHOLD2SIGN      INTEGER,
  CONSTRAINT XPKSBI_GOAL_KPI PRIMARY KEY (GOAL_KPI_ID)
) WITHOUT OIDS;

			
			
ALTER TABLE SBI_GOAL ADD FOREIGN KEY ( GRANT_ID ) REFERENCES SBI_ORG_UNIT_HIERARCHIES ( ID ) ON DELETE CASCADE;
ALTER TABLE SBI_GOAL_HIERARCHY ADD FOREIGN KEY (GOAL_ID) REFERENCES SBI_GOAL (GOAL_ID) ON DELETE CASCADE;
ALTER TABLE SBI_GOAL_HIERARCHY ADD FOREIGN KEY (PARENT_ID) REFERENCES SBI_GOAL_HIERARCHY (GOAL_HIERARCHY_ID) ON DELETE CASCADE;
ALTER TABLE SBI_GOAL_KPI ADD FOREIGN KEY (GOAL_HIERARCHY_ID) REFERENCES SBI_GOAL_HIERARCHY (GOAL_HIERARCHY_ID)  ON DELETE CASCADE;
ALTER TABLE SBI_GOAL_KPI ADD FOREIGN KEY (KPI_INSTANCE_ID) REFERENCES SBI_KPI_MODEL_INST (KPI_MODEL_INST) ON DELETE CASCADE;

